#include "DeskIcon.h"

#include "Pics/Lightbulb.xpm"


extern void 	cbCloseWindow(Fl_Widget*, Fl_Window*);//ok

void 		icon_edit_dialog(int edit, char* cfg, DeskIcon*w);

Fl_Input 	*filename_field_icon, *name_field_icon;  
Fl_Input 	*command_field_icon, *icon_field_icon;



inline void DeskIcon:://out ...
EditIconFromLabel_I(Fl_Widget*, char *configFile)
{
    icon_edit_dialog(1, configFile, this);

}

void DeskIcon::
EditIconFromLabel(Fl_Widget *o, char *c)
{
  ((DeskIcon*)(o->user_data()))->EditIconFromLabel_I(o, c);
}

DeskIcon::
DeskIcon(char *config) : Icon(config)
{
    int X, Y;
    char *deskIconName = new char[80];
    cfg = config;
    end();
    
    Fl_Config iconfig(config);
    iconfig.get("Desktop Entry/X", X);
    iconfig.get("Desktop Entry/Y", Y);
    iconfig.get("Desktop Entry/Name", deskIconName, 80);
	
    width = (int) fl_width(deskIconName) + 10;
	
    label_window = new Fl_Window(X - ( (width - 48) /2 ), Y + 50, width, 15, deskIconName);
    label_window->box(FL_EMBOSSED_BOX);
    label_window->color(FL_WHITE);
    label_window->label_color(FL_BLACK);
    label_window->align(FL_ALIGN_INSIDE| FL_ALIGN_LEFT);
    label_window->callback( (Fl_Callback*) EditIconFromLabel, config);
    label_window->clear_border();
    label_window->end();
    label_window->show();
}


Icon::
Icon(char *icon_config) : Fl_Window(0, 0, 48, 48)
{
    struct stat s;
    char **d = NULL;
    char iconFile[1024];
    char iconName[80];
    int x = 100;
    int y = 100;
    int fd;

    pix = 0;
    mask = 0;
    pix_data = NULL;
    win = 0;
    cfg = icon_config;

    Fl_Config icon_cfg(icon_config);
    icon_cfg.get("Desktop Entry/Icon", iconFile, 1024);
    icon_cfg.get("Desktop Entry/X", x);
    icon_cfg.get("Desktop Entry/Y", y);
    position(x, y);
    
    icon_cfg.get("Desktop Entry/Name", iconName, 80);
    char *tooltipName = new char [strlen(iconName) + 1];
    strcpy(tooltipName, iconName);
    tooltip(tooltipName);
    end();

	
    if (!stat(iconFile, &s) && s.st_size > 10) {
	pix_data = (char*) malloc(s.st_size);
	fd = open(iconFile, O_RDONLY);
	if (fd < 0) 
	    return;
	read(fd, pix_data, s.st_size);	
	close(fd);
	d = parse_xpm(pix_data, s.st_size);
    }
    if (d) {
	win = create_window(d, &pix, &mask);
    } 
    else {
    	win = create_window(lightbulb_xpm, &pix, &mask);
    }
}

Icon::~Icon()
{
	free(pix_data);
	XFreePixmap(fl_display, mask);
	XFreePixmap(fl_display, pix);
}

void DeskIcon::
exec_cb()
{
    char command[1024];
    Fl_Config flconfig(cfg);
    flconfig.get("Desktop Entry/Exec", command, 1024);
    char *exec_staff = new char[ strlen( command ) + 5 ];    
    sprintf(exec_staff, "%s &", command);
    system(exec_staff);
    delete [] exec_staff;
}


int DeskIcon::
handle(int e)
{
    static int bx, by;
    static int button1 = 0;
    static int button3 = 0;
    
    if (e == FL_PUSH) {
	button1 = (Fl::event_button() == 1);
	button3 = (Fl::event_button() == 3);
	label_window->color(FL_BLUE_SELECTION_COLOR);
	label_window->label_color(FL_WHITE);
	label_window->redraw();
    }
    if (button3) 
	switch(e) {
	    case FL_PUSH:
		icon_edit_dialog(1, cfg, this);
    }
    if (button1) 
	switch(e) {
	    case FL_DRAG:
		{
    		position(x()+Fl::event_x_root()-bx, y()+Fl::event_y_root()-by);
		label_window->position(label_window->x()+Fl::event_x_root()-bx, 
		    label_window->y()+Fl::event_y_root()-by );
		}
	    case FL_PUSH:
	        bx = Fl::event_x_root(); 
		by = Fl::event_y_root();
		if (Fl::event_clicks() > 0) {
		    Fl::event_clicks(0);	
		    exec_cb();
		}
                return 1;
	}

	switch (e) {
	case FL_RELEASE: {
	    Fl_Config icfg(cfg);
	    icfg.set("Desktop Entry/X", x());
	    icfg.set("Desktop Entry/Y", y());
	    label_window->color(FL_WHITE);
	    label_window->label_color(FL_BLACK);
	    label_window->redraw();
	    }
	case FL_ENTER:	    
	case 0:
	case FL_SHOW:
	case FL_HIDE:
	case FL_FOCUS:
	case FL_UNFOCUS:
	case FL_LEAVE:
	case FL_MOVE:
		return Icon::handle(e);
	default:
		break;
	}
	return Icon::handle(e);
}


void Icon::
draw()
{
}


void Icon::
show()
{
    return Fl_Window::show();
}


void Icon::
hide()
{
    return Fl_Window::hide();
}


char **Icon::
parse_xpm(char *d, int l)
{
    char **p = NULL;
    int in_quote = 0;
    int r = 0;
    int i = 0;

    while (i < l) { // skip comments
	if (!in_quote && d[i] == '/' && d[i + 1] == '*') {
            i += 2;
            while (i < l) {
                if (d[i] == '*' && d[i + 1] == '/') {
                    i += 2;
                    break;
                }
                i++;
            }
        }

        if (!in_quote && d[i] == '"') {  // string beginning
            p = (char**) realloc(p, sizeof(char*) * (r + 1));
            p[r] = d + i + 1;
            in_quote = 1;
        } 
	else if (in_quote && d[i] == '"') { // string end
            d[i] = '\0';
            in_quote = 0;
        } 
	else if (!in_quote && d[i] == ',') {  // end of line
            r++;
        }
        i++;
    }
    return p;
}

Window Icon::
create_window(char **data, Pixmap *pix, Pixmap *mask)
{
    Window win = 0;
    unsigned long valuemask;
    XSetWindowAttributes attributes;
    XpmAttributes xpm_attributes;
    
    fl_open_display();
    Fl_X::create(this, fl_visual, fl_colormap, -1);
    valuemask = CWEventMask | CWOverrideRedirect | CWSaveUnder;
//  	valuemask = CWColormap |CWEventMask | CWOverrideRedirect | CWSaveUnder;    
    attributes.override_redirect = 1;
    attributes.save_under = 1;
    attributes.event_mask = ExposureMask|StructureNotifyMask
	|KeyPressMask|KeyReleaseMask|KeymapStateMask|FocusChangeMask
	|ButtonPressMask|ButtonReleaseMask 
	|EnterWindowMask|LeaveWindowMask
	|PointerMotionMask;
    attributes.colormap = fl_colormap;

    win = fl_xid(this);
    XChangeWindowAttributes(fl_display, win, valuemask, &attributes);
    if (!win) 
	return 0;
	
    xpm_attributes.colormap = fl_colormap;
    xpm_attributes.valuemask = XpmSize | XpmReturnPixels | XpmColormap;
    
    XpmCreatePixmapFromData(fl_display, win, data, pix, mask, &xpm_attributes);
    XShapeCombineMask(fl_display, win, ShapeBounding, 0, 0, *mask, ShapeSet);
    XSetWindowBackgroundPixmap(fl_display, win, *pix);
    return win;
}


void DeskIcon::
update_label(char *icon_config)
{
    char iconName[80];

    Fl_Config icon_cfg(icon_config);
    icon_cfg.get("Desktop Entry/Name", iconName, 80);
	char *text = new char [strlen(iconName) + 1];
	strcpy(text, iconName);
	int width = (int) fl_width(text) + 10;
	label_window->resize(x()-((width-48)/2), y() + 50, width, 15);
	label_window->label(text);
	label_window->redraw();
}


void Icon::
update_all(char *icon_config)
{
    struct stat s;
    char **d = NULL;
    char iconFile[1024];
    char iconName[80];
    int x, y;
    int fd;

    pix = 0;
    mask = 0;
    pix_data = NULL;
    cfg = icon_config;
	
    Fl_Config icon_cfg(icon_config);
    icon_cfg.get("Desktop Entry/Icon", iconFile, 80);
    icon_cfg.get("Desktop Entry/X", x);
    icon_cfg.get("Desktop Entry/Y", y);
    position(x, y);
	
    icon_cfg.get("Desktop Entry/Name", iconName, 80);
    char *tooltipName = new char [strlen(iconName) + 1];
    strcpy(tooltipName, iconName);
    tooltip(tooltipName);
	
    if (!stat(iconFile, &s) && s.st_size > 10) {
	pix_data = (char*) malloc(s.st_size);
	fd = open(iconFile, O_RDONLY);
	if (fd < 0) 
	    return;

	read(fd, pix_data, s.st_size);	
	close(fd);
	d = parse_xpm(pix_data, s.st_size);
    }
    if (d) {
        update_icon(d, &pix, &mask);
    } 
    else {
	update_icon(lightbulb_xpm, &pix, &mask);
    }

}


void Icon::
update_icon(char **data, Pixmap *pix, Pixmap *mask)
{
    Window win = 0;
    XpmAttributes xpm_attributes;

    win = fl_xid(this);

    xpm_attributes.colormap = fl_colormap;
    xpm_attributes.valuemask = XpmSize|XpmReturnPixels|XpmColormap;

    XpmCreatePixmapFromData(fl_display,win,data,pix,mask,&xpm_attributes);
    XShapeCombineMask(fl_display, win, ShapeBounding, 0, 0, *mask, ShapeSet);
    XSetWindowBackgroundPixmap(fl_display, win, *pix);
    XClearWindow (fl_display, win);
}

void 
cb_save_icon(Fl_Widget *a, DeskIcon *icon_window)
{
    char *item = (char*) filename_field_icon->value();
    
    Fl_Config flconfig(item);
    flconfig.set("Desktop Entry/Name", name_field_icon->value());
    flconfig.set("Desktop Entry/Exec", command_field_icon->value());
    flconfig.set("Desktop Entry/Icon", icon_field_icon->value());

    icon_window->update_all(item);
    icon_window->update_label(item);
    
}


void 
cb_delete_icon(Fl_Widget*, DeskIcon *icon_window)
{
    char *item = (char*) filename_field_icon->value();
    
    if ( fl_ask("Realy delete this icon?") ) {
	icon_window->hide();
	icon_window->label_window->hide();
	
	if ( remove(item) < 0) 
	    fl_alert("Cannot remove icon file %s\nProbably you dont have access\n to this dir or file", item);
    }
}



void 
cb_browse_icon_file(Fl_Widget *w, Fl_Input *input)
{
    char *fileName = fl_file_chooser("Find icon file ...", "*.xpm", input->value());
    if (fileName)  
	input->value(fileName);

}

void
icon_edit_dialog(int edit, char* cfg, DeskIcon *iwin)
{ 
    Fl_Window *edit_window = new Fl_Window(370, 250, "Edit icon properties" );

    filename_field_icon = new Fl_Input(5, 25, 195, 23, "Filename:" );
    filename_field_icon->align(FL_ALIGN_TOP | FL_ALIGN_LEFT);
    filename_field_icon->value("The Gimp.desktop");
    
    name_field_icon = new Fl_Input(5, 80, 195, 23,  "Icon name:");
    name_field_icon->align(FL_ALIGN_TOP | FL_ALIGN_LEFT);
    name_field_icon->value("The Gimp");
    
    command_field_icon = new Fl_Input(5, 125, 195, 23, ("Program to execute:"));
    command_field_icon->align(FL_ALIGN_TOP | FL_ALIGN_LEFT);
    command_field_icon->value("gimp");
    
    {
    Fl_Button *browse_button_c = new Fl_Button(210, 125, 80, 23, ("F&ind ..."));
    browse_button_c->callback( (Fl_Callback*) cb_browse_icon_file, command_field_icon );
    }
    
    icon_field_icon = new Fl_Input(5, 215, 195, 23, "Filename of the icon:" );
    icon_field_icon->align(FL_ALIGN_TOP | FL_ALIGN_LEFT);
    icon_field_icon->value("/usr/share/icons");
    
    {
    Fl_Button *save_button = new Fl_Button(285, 25, 80, 23, ("&Apply"));
    save_button->callback( (Fl_Callback*) cb_save_icon, iwin );
    }
    {
    Fl_Button *delete_button = new Fl_Button(285, 60, 80, 23, ("&Delete"));
    delete_button->callback( (Fl_Callback*) cb_delete_icon, iwin );
    }
    {
    Fl_Button *cancel_button = new Fl_Button(285, 95, 80, 23, ("&Close"));
    cancel_button->callback( (Fl_Callback*) cbCloseWindow, edit_window );
    }
    {
    Fl_Button *browse_button_i = new Fl_Button(210, 215, 80, 23, ("&Find ..."));
    browse_button_i->callback( (Fl_Callback*) cb_browse_icon_file, icon_field_icon );
    }
    
    if (edit) {
	char val[80];
        Fl_Config flconfig(cfg);
	
	filename_field_icon->value(cfg);
	filename_field_icon->deactivate();
	
        flconfig.get("Desktop Entry/Name", val, 80 );
        name_field_icon->value(val);
	
        flconfig.get("Desktop Entry/Exec", val, 80 );
        command_field_icon->value(val);
	
        flconfig.get("Desktop Entry/Icon", val, 80 );
        icon_field_icon->value(val);
    }
        
    edit_window->end();
    edit_window->show();
}

