#ifndef DeskIcon_h
#define DeskIcon_h

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/x.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Pixmap.H>
#include <FL/Fl_Input.H>
#include <FL/fl_config.H>
#include <FL/fl_ask.H>
#include <FL/Fl_Button.H>
#include <FL/fl_file_chooser.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Item.H>
#include <FL/fl_draw.H>

#include <X11/xpm.h>
#include <X11/extensions/shape.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
//#include <X11/Xatom.h>




class Icon : public Fl_Window {

public:
	Pixmap pix;
	Pixmap mask;
	char *pix_data;
	char *cfg;
	Window win;
//	Fl_Window *text_window;

	Icon(char *icon_config);

	~Icon();
	void show();
	void hide();
	void draw();
	virtual int handle(int e) { return Fl_Window::handle(e); }
	static char **parse_xpm(char *d, int l);
	Window create_window(char **d, Pixmap *p, Pixmap *m);
	void update_all(char *icon_config);
	void update_icon(char **data, Pixmap *pix, Pixmap *mask);
};



class DeskIcon : public Icon {
    int width;
    
public:
    void exec_cb();
    
    DeskIcon(char *config);
    int handle(int e);
    void update_label(char *icon_config);
    
    inline void EditIconFromLabel_I(Fl_Widget*, char *configFile);
    static void EditIconFromLabel(Fl_Widget*, char *configFile);
    

    
    
    Icon *iw;
    Fl_Window *label_window;
    char *cfg;
};


#endif 

