#include "PanelButton.h"

void PanelButton::
draw() 
{
  Fl_Flags flags = draw_button(0);
  int X = x(); int Y = y(); int W = w(); int H = h(); box()->inset(X, Y, W, H);
  draw_inside_label(X, Y, W, H, flags);
}

int PanelButton::
popup() 
{
  if ( is_down_box == 1 )  
   return Fl_Menu_::popup(Fl::event_x(), Fl::event_y(), label());
  else
   return pulldown( x(), y() - up_width, w(), h() );
}

int PanelButton::
handle(int e) 
{
    switch (e) {
	case FL_PUSH:
	    if ( type() & 7 ) {
    		if (!(type() & (1 << (Fl::event_button()-1)))) 
		    return 0;
	    } 
	    else { 
		take_focus(); 
	    }
	    if (!(type()&7)) value(-1); popup();  return 1;
	    
        case FL_ENTER:  
	    if ( is_prelight_on == 1 ) { 
		box(FL_DOWN_BOX); 
            }
	break;
	
	case FL_RELEASE:  
	case FL_LEAVE:  
	    if ( is_prelight_on == 1 ) { 
		box(FL_UP_BOX); 
    	    }
        break;
    }
    return Fl_Menu_Button::handle(e);
}
