#include "Tasks.h"
#include "WmComm.h"


extern Fl_Scroll*task_scroll;
extern int 	max_scroll;
extern int 	fd[2];

int origin 	= 80; 
int first_time 	= 1;
int origin_y 	= 3;

int 
get_state(Window w)
{
    Atom real_type;
    int real_format, state = 0;
    unsigned long n, extra;
    unsigned char *data;

    if (XGetWindowProperty(fl_display, w,  XInternAtom(fl_display, "WM_STATE", False), 0L, 2L, False, AnyPropertyType,
	&real_type, &real_format, &n, &extra, &data) == Success && n) {
	state = *(int *)data;
	XFree(data);
    }
    return state;
}


void 
raise_window(Window *w)
{
  XMapRaised(fl_display, (Window) w);
  XSync(fl_display, False);
}

void 
minimize_window(void *w)
{
  sendinfo (fd, "Iconify", (unsigned long) w);
}


//int to_raise = 0;

void 
change_window_state(Fl_Button *b, Window *w)
{
    static int to_raise = 0;
//    raise_window(w); 

    if (to_raise == 1) {
	raise_window(w); 
	to_raise = 0;
    }
    else {
	minimize_window(w); 
	to_raise = 1; 
    }
}


void 
create_tasks_buttons(Window w)
{
    char *buf;
    Fl_Button *b;
    char *buf1 = new char[10];
	
    //Status l  = XGetIconName(fl_display, w, &buf);
    Status l = XFetchName(fl_display, w, &buf);

    if ( l == 0 ) {
	buf1 = ("Equinox"); 
	buf = ("Equinox");  
    }
    else {
	strncpy(buf1, buf, 10);
	buf1[6] = '.', buf1[7] = '.', buf1[8] = '.'; buf1[9] = '\0';
    }
	
    char *buf2 = new char[ strlen(buf) + 1 ];
    strcpy(buf2, buf );
	
    task_scroll->begin(); 
	
    if ( origin <= (max_scroll - 0)  ) 
        b = new Fl_Button(origin, origin_y, 80, 22, buf1); 
	 
    else {
        if (first_time) 
	    origin = 80; 
	    origin_y += 23; 
        b = new Fl_Button(origin, origin_y, 80, 22, buf1); 
        first_time = 0;
        if (origin <= max_scroll) 
	    first_time = 1;
    }
    b->align( FL_ALIGN_LEFT | FL_ALIGN_INSIDE );
    b->image( new Fl_Pixmap(item_xpm) );
    b->tooltip(buf2);
    b->callback( (Fl_Callback *) change_window_state, (void*) w );
	
    task_scroll->end();
    task_scroll->redraw();
	
    origin += 81; 
    if ( l != 0 ) 
	XFree(buf);
}

void 
scan_tasks_windows(Window root)
{
    Window dummy, *wins;
    unsigned int i, nwins;
    
    if (XQueryTree(fl_display, root, &dummy, &dummy, &wins, &nwins) && wins) {
	for (i = 0; i < nwins; i++) {
	    if (get_state(wins[i]) > 0) 
		create_tasks_buttons(wins[i]);
	    else 
		scan_tasks_windows(wins[i]);
	}
	XFree(wins);
    }
}


void
task_refresh(void*) 
{
    Window Root;
    Atom xa_wm_state;

    task_scroll->clear(); 
    task_scroll->redraw(); 
    task_scroll->window()->redraw(); 
    
    Root = RootWindow(fl_display, fl_screen);
    XSelectInput(fl_display, Root, SubstructureNotifyMask);

    xa_wm_state = XInternAtom(fl_display, "WM_STATE", False);

    
    scan_tasks_windows(Root);
    origin = 80;
    origin_y = 3; 
}

