#ifndef __CONSTANT_H__
#define __CONSTANT_H__


#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define SMALL_PANEL_ICONS  45
#define MEDIUM_PANEL_ICONS 60
#define LARGE_PANEL_ICONS  75

#define SMALL_POPUP_ICONS  30
#define MEDIUM_POPUP_ICONS 50
#define LARGE_POPUP_ICONS  70

#define EQUINOX_CURS    XC_left_ptr
#define MENU_CURS    XC_right_ptr

#ifndef PATH_MAX
#define DEFAULT_LENGTH 1024
#else
#if (PATH_MAX < 1024)
#define DEFAULT_LENGTH 1024
#else
#define DEFAULT_LENGTH PATH_MAX
#endif
#endif

#ifndef DEFAULTENGINE
#define DEFAULTENGINE 	"equinox"
#endif

#ifndef DEFAULTFONT
#define DEFAULTFONT 	"-*-helvetica-medium-r-normal-*-10-*-*-*-p-*-*-*"
#endif

#ifndef TIPFONT
#define TIPFONT 	DEFAULTFONT
#endif

#ifndef BACKUPEXT
#define BACKUPEXT 	".bak"
#endif

#ifndef DEFAULT_SHELL
#define DEFAULT_SHELL 	"/bin/sh"
#endif

#ifndef EQUINOX_DIR
#define EQUINOX_DIR        "/usr/share/equinox"
#endif

#ifndef EQUINOX_PAL
#define EQUINOX_PAL 	"/palettes/"
#endif

#ifndef EQUINOX_BACKDROPS
#define EQUINOX_BACKDROPS 	"/backdrops/"
#endif

#ifndef EQUINOX_ICONS
#define EQUINOX_ICONS 	"/icons/"
#endif

#ifndef EQUINOX_SOUNDS
#define EQUINOX_SOUNDS 	"/sounds/"
#endif

#ifndef XBINDIR
#define XBINDIR 	"/usr/X11R6/bin/"
#endif

#ifndef EQUINOX_LOGO
#define EQUINOX_LOGO 	"/equinox.logo"
#endif

#ifndef EQUINOX_LICENSE
#define EQUINOX_LICENSE 	"/COPYING"
#endif

#ifndef XFWM_TITLEFONT
#define XFWM_TITLEFONT 	"-*-lucida-medium-r-*-*-12-*-*-*-*-*-*-*"
#endif

#ifndef XFWM_MENUFONT
#define XFWM_MENUFONT 	"-*-lucida-medium-r-*-*-12-*-*-*-*-*-*-*"
#endif

#ifndef XFWM_ICONFONT
#define XFWM_ICONFONT 	"-*-lucida-medium-r-*-*-12-*-*-*-*-*-*-*"
#endif


#ifndef NBMAXITEMS
#define NBMAXITEMS 	15
#endif

#ifndef MINRESISTANCE
#define MINRESISTANCE 	6
#endif

#ifndef EDGEFACTOR
#define EDGEFACTOR 	3
#endif

#ifndef NBMAXITEMS
#define NBMAXITEMS 	15
#endif

#ifndef MAXSTRLEN
#define MAXSTRLEN 	DEFAULT_LENGTH
#endif

#ifndef NAME_MAX
#define NAME_MAX 	DEFAULT_LENGTH
#endif

#ifndef PATH_MAX
#define PATH_MAX 	DEFAULT_LENGTH
#endif

#ifndef TERMINAL
#define TERMINAL "xterm"
#endif

#ifndef MAILCHECK_PERIOD
#define MAILCHECK_PERIOD 10000
#endif

#define NBSCREENS   	 3
#define NBPOPUPS	 12
#define NBSELECTS 	 NBPOPUPS+1
#define NB_EQUINOX_COLORS 	 8
#define NB_PANEL_ICONS 	 13
#define DEFAULT_ICON_SEQ "0,5,1,4,2,3,6,7,8,9,10,11,12"
#endif
